module     p0_dubar_emnebarbbbar_d22h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d22h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d22
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd22h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb22n11+abb22n20*(spval6k1(1)*qshift(1)-spval6k1(2)*qshif&
         &t(2)-spval6k1(3)*qshift(3)-spval6k1(4)*qshift(4))+abb22n21*(spvak2k1(1&
         &)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qs&
         &hift(4))+abb22n22*(spval6k4(1)*qshift(1)-spval6k4(2)*qshift(2)-spval6k&
         &4(3)*qshift(3)-spval6k4(4)*qshift(4))+abb22n23*dotproduct(k1, qshift)+&
         &abb22n24*dotproduct(k3, qshift)+abb22n24*dotproduct(k4, qshift)+abb22n&
         &25*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-&
         &spvak3k4(4)*qshift(4))+abb22n26*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qsh&
         &ift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qshift(4))+abb22n27*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb22n16+k3(iv1)*abb22n15+k4(iv1)*abb22n15+spvak2k&
         &1(iv1)*abb22n18+spvak2k4(iv1)*abb22n13+spvak3k1(iv1)*abb22n12+spvak3k4&
         &(iv1)*abb22n14+spval6k1(iv1)*abb22n19+spval6k4(iv1)*abb22n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d22:
   subroutine     reconstruct_d22(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_22:
      coeffs%coeffs_22%c0 = derivative(czip)
      coeffs%coeffs_22%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_22%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_22%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_22%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_22:
   end subroutine reconstruct_d22
!---#] subroutine reconstruct_d22:
end module p0_dubar_emnebarbbbar_d22h1l1d
