module     p0_dubar_emnebarbbbar_d24h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity2/d24h2l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t33 = dotproduct(qshift, qshift)
      t34 = dotproduct(l5, qshift)
      t35 = dotproduct(k1, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t36 = dotproduct(k2, qshift)
      t4 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t5 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t6 = (spvak3l6(1)*qshift(1)-spvak3l6(2)*qshift(2)-spvak3l6(3)*qshift(3)-sp&
      &vak3l6(4)*qshift(4))
      t37 = dotproduct(l6, qshift)
      t7 = (spval5l6(1)*qshift(1)-spval5l6(2)*qshift(2)-spval5l6(3)*qshift(3)-sp&
      &val5l6(4)*qshift(4))
      t8 = (spval5k4(1)*qshift(1)-spval5k4(2)*qshift(2)-spval5k4(3)*qshift(3)-sp&
      &val5k4(4)*qshift(4))
      t9 = (spval5k2(1)*qshift(1)-spval5k2(2)*qshift(2)-spval5k2(3)*qshift(3)-sp&
      &val5k2(4)*qshift(4))
      t10 = (spvak1l6(1)*qshift(1)-spvak1l6(2)*qshift(2)-spvak1l6(3)*qshift(3)-s&
      &pvak1l6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb24n33+t1*abb24n58+t2*abb24n59+t3*abb24n60+t33*abb24n54+&
         &t34*abb24n55+t35*abb24n57+t36*abb24n63+t1*t2*abb24n46+t1*t3*abb24n53+t&
         &1*t36*abb24n41+t10*t4*abb24n52+t3*t33*abb24n61+t3*t34*abb24n48+t3*t35*&
         &abb24n49+t3*t36*abb24n47+t3*t4*abb24n34+t3*t8*abb24n45+t3*t9*abb24n50+&
         &t33*t5*abb24n64+t34*t5*abb24n43+t35*t5*abb24n42+t36*t4*abb24n37+t36*t5&
         &*abb24n40+t36*t7*abb24n51+t37*t4*abb24n38+t4*t5*abb24n35+t4*t6*abb24n3&
         &6+t4*t7*abb24n39+t5*t7*abb24n44+t1*t2*t7*abb24n66)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = l5(iv1)
      t14 = qshift(iv1)
      t15 = spvak2k1(iv1)
      t16 = spvak2l6(iv1)
      t17 = spvak3k4(iv1)
      t18 = l6(iv1)
      t19 = spvak1l6(iv1)
      t20 = spvak2k4(iv1)
      t21 = spvak3l6(iv1)
      t22 = spval5k1(iv1)
      t23 = spval5k2(iv1)
      t24 = spval5k4(iv1)
      t25 = spval5l6(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb24n57+t12*abb24n63+t13*abb24n55+t14*abb24n56+t15*ab&
         &b24n59+t16*abb24n60+t17*abb24n58+t1*t12*abb24n41+t1*t15*abb24n46+t1*t1&
         &6*abb24n53+t10*t22*abb24n52+t11*t3*abb24n49+t11*t5*abb24n42+t12*t3*abb&
         &24n47+t12*t4*abb24n37+t12*t5*abb24n40+t12*t7*abb24n51+t13*t3*abb24n48+&
         &t13*t5*abb24n43+t14*t3*abb24n62+t14*t5*abb24n65+t16*t33*abb24n61+t16*t&
         &34*abb24n48+t16*t35*abb24n49+t16*t36*abb24n47+t16*t4*abb24n34+t16*t8*a&
         &bb24n45+t16*t9*abb24n50+t17*t2*abb24n46+t17*t3*abb24n53+t17*t36*abb24n&
         &41+t18*t4*abb24n38+t19*t4*abb24n52+t20*t33*abb24n64+t20*t34*abb24n43+t&
         &20*t35*abb24n42+t20*t36*abb24n40+t20*t4*abb24n35+t20*t7*abb24n44+t21*t&
         &4*abb24n36+t22*t3*abb24n34+t22*t36*abb24n37+t22*t37*abb24n38+t22*t5*ab&
         &b24n35+t22*t6*abb24n36+t22*t7*abb24n39+t23*t3*abb24n50+t24*t3*abb24n45&
         &+t25*t36*abb24n51+t25*t4*abb24n39+t25*t5*abb24n44+t1*t15*t7*abb24n66+t&
         &1*t2*t25*abb24n66+t17*t2*t7*abb24n66)
         return
      end if
      t33 = d(iv1,iv2)
      t4 = spvak2k4(iv2)
      t6 = spvak2l6(iv2)
      t8 = k1(iv2)
      t9 = spvak3k4(iv2)
      t10 = spval5k1(iv2)
      t26 = spval5l6(iv2)
      t27 = k2(iv2)
      t28 = l5(iv2)
      t29 = qshift(iv2)
      t30 = t15*t9
      t31 = spvak2k1(iv2)
      t32 = t17*t31
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t33*abb24n54+t3*t33*abb24n61+t33*t5*abb24n64)+t3&
         &0*abb24n46+t32*abb24n46+l6(iv2)*t22*abb24n38+spvak1l6(iv2)*t22*abb24n5&
         &2+spvak3l6(iv2)*t22*abb24n36+spval5k2(iv2)*t16*abb24n50+spval5k4(iv2)*&
         &t16*abb24n45+t10*t12*abb24n37+t10*t16*abb24n34+t10*t18*abb24n38+t10*t1&
         &9*abb24n52+t10*t20*abb24n35+t10*t21*abb24n36+t10*t25*abb24n39+t11*t4*a&
         &bb24n42+t11*t6*abb24n49+t12*t26*abb24n51+t12*t4*abb24n40+t12*t6*abb24n&
         &47+t12*t9*abb24n41+t13*t4*abb24n43+t13*t6*abb24n48+t14*t4*abb24n65+t14&
         &*t6*abb24n62+t16*t27*abb24n47+t16*t28*abb24n48+t16*t29*abb24n62+t16*t8&
         &*abb24n49+t16*t9*abb24n53+t17*t27*abb24n41+t17*t6*abb24n53+t20*t26*abb&
         &24n44+t20*t27*abb24n40+t20*t28*abb24n43+t20*t29*abb24n65+t20*t8*abb24n&
         &42+t22*t26*abb24n39+t22*t27*abb24n37+t22*t4*abb24n35+t22*t6*abb24n34+t&
         &23*t6*abb24n50+t24*t6*abb24n45+t25*t27*abb24n51+t25*t4*abb24n44+t30*t7&
         &*abb24n66+t32*t7*abb24n66+t1*t15*t26*abb24n66+t1*t25*t31*abb24n66+t17*&
         &t2*t26*abb24n66+t2*t25*t9*abb24n66)
         return
      end if
      t34 = d(iv2,iv3)
      t35 = d(iv1,iv3)
      t1 = spval5l6(iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t33*abb24n64+spvak2l6(iv3)*t33*abb&
         &24n61+t16*t34*abb24n61+t20*t34*abb24n64+t35*t4*abb24n64+t35*t6*abb24n6&
         &1)+t1*t30*abb24n66+t1*t32*abb24n66+t15*t2*t26*abb24n66+t17*t26*t3*abb2&
         &4n66+t2*t25*t31*abb24n66+t25*t3*t9*abb24n66)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p0_dubar_emnebarbbbar_d24h2l1d
