module     p0_dubar_emnebarbbbar_d25h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity2/d25h2l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d25
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      real(ki) :: t28
      real(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t28 = dotproduct(qshift, qshift)
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t29 = dotproduct(k2, qshift)
      t2 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t30 = dotproduct(k1, qshift)
      t4 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t31 = dotproduct(l6, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak3l6(1)*qshift(1)-spvak3l6(2)*qshift(2)-spvak3l6(3)*qshift(3)-sp&
      &vak3l6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb25n33+t1*abb25n98+t1*t1*abb25n58+t2*abb25n66+t28*abb25n&
         &47+t29*abb25n65+t3*abb25n67+t30*abb25n71+t31*abb25n79+t4*abb25n78+abb2&
         &5n64*(spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3&
         &)-spvak2l5(4)*qshift(4))+abb25n70*(spvak1l6(1)*qshift(1)-spvak1l6(2)*q&
         &shift(2)-spvak1l6(3)*qshift(3)-spvak1l6(4)*qshift(4))+abb25n91*(spval6&
         &k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-spval6k1(4&
         &)*qshift(4))+t1*t2*abb25n36+t1*t28*abb25n87+t1*t3*abb25n35+t1*t30*abb2&
         &5n44+t1*t31*abb25n46+t1*t4*abb25n43+t28*t3*abb25n82+t28*t5*abb25n94+t2&
         &8*t6*abb25n74+t29*t5*abb25n38+t29*t6*abb25n52+t3*t30*abb25n48+t3*t31*a&
         &bb25n49+t3*t4*abb25n59+t30*t5*abb25n41+t30*t6*abb25n55+t31*t5*abb25n39&
         &+t31*t6*abb25n53+t1*t29*t3*abb25n101)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = l6(iv1)
      t10 = qshift(iv1)
      t11 = spvak2k1(iv1)
      t12 = spvak2k4(iv1)
      t13 = spvak2l6(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak3l6(iv1)
      if(deg.eq.1) then
         numerator = (spvak1l6(iv1)*abb25n57+spvak2l5(iv1)*abb25n63+spval6k1(iv1&
         &)*abb25n42+t10*abb25n84+t11*abb25n37+t12*abb25n61+t13*abb25n51+t14*abb&
         &25n60+t7*abb25n56+t8*abb25n62+t9*abb25n50+t1*t10*abb25n86+t1*t11*abb25&
         &n69+t1*t12*abb25n99+t1*t13*abb25n90+t1*t14*abb25n100+t1*t7*abb25n89+t1&
         &*t9*abb25n85+t10*t3*abb25n81+t10*t5*abb25n93+t10*t6*abb25n73+t11*t2*ab&
         &b25n99+t11*t28*abb25n45+t11*t3*abb25n100+t11*t30*abb25n89+t11*t31*abb2&
         &5n85+t11*t4*abb25n90+t13*t3*abb25n68+t14*t28*abb25n48+t14*t30*abb25n82&
         &+t14*t31*abb25n80+t14*t4*abb25n68+t15*t28*abb25n40+t15*t29*abb25n97+t1&
         &5*t30*abb25n92+t15*t31*abb25n96+t16*t28*abb25n54+t16*t29*abb25n77+t16*&
         &t30*abb25n72+t16*t31*abb25n76+t3*t7*abb25n82+t3*t9*abb25n80+t5*t7*abb2&
         &5n92+t5*t8*abb25n97+t5*t9*abb25n96+t6*t7*abb25n72+t6*t8*abb25n77+t6*t9&
         &*abb25n76+t1*t14*t29*abb25n34+t1*t3*t8*abb25n34+t11*t29*t3*abb25n34)
         return
      end if
      t28 = d(iv1,iv2)
      t2 = spvak2k1(iv2)
      t4 = spvak3k1(iv2)
      t17 = spvak3k4(iv2)
      t18 = spvak3l6(iv2)
      t19 = k1(iv2)
      t20 = k2(iv2)
      t21 = l6(iv2)
      t22 = qshift(iv2)
      t23 = spvak2l6(iv2)
      t24 = t11*t17
      t25 = t14*t2
      t26 = t2*t8
      t27 = t11*t20
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t28*abb25n47+t1*t28*abb25n87+t11*t2*abb25n58+t28&
         &*t3*abb25n82+t28*t5*abb25n94+t28*t6*abb25n74)+t24*abb25n35+t25*abb25n3&
         &5+spvak2k4(iv2)*t11*abb25n36+t10*t17*abb25n83+t10*t18*abb25n75+t10*t2*&
         &abb25n88+t10*t4*abb25n95+t11*t19*abb25n44+t11*t21*abb25n46+t11*t22*abb&
         &25n88+t11*t23*abb25n43+t12*t2*abb25n36+t13*t17*abb25n59+t13*t2*abb25n4&
         &3+t14*t19*abb25n48+t14*t21*abb25n49+t14*t22*abb25n83+t14*t23*abb25n59+&
         &t15*t19*abb25n41+t15*t20*abb25n38+t15*t21*abb25n39+t15*t22*abb25n95+t1&
         &6*t19*abb25n55+t16*t20*abb25n52+t16*t21*abb25n53+t16*t22*abb25n75+t17*&
         &t7*abb25n48+t17*t9*abb25n49+t18*t7*abb25n55+t18*t8*abb25n52+t18*t9*abb&
         &25n53+t2*t7*abb25n44+t2*t9*abb25n46+t24*t29*abb25n101+t25*t29*abb25n10&
         &1+t26*t3*abb25n101+t27*t3*abb25n101+t4*t7*abb25n41+t4*t8*abb25n38+t4*t&
         &9*abb25n39+t1*t14*t20*abb25n101+t1*t17*t8*abb25n101)
         return
      end if
      t29 = d(iv2,iv3)
      t30 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t3 = spvak3k4(iv3)
      t5 = k2(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t28*abb25n40+spvak3l6(iv3)*t28*abb&
         &25n54+t1*t28*abb25n45+t11*t29*abb25n45+t14*t29*abb25n48+t15*t29*abb25n&
         &40+t16*t29*abb25n54+t17*t30*abb25n48+t18*t30*abb25n54+t2*t30*abb25n45+&
         &t28*t3*abb25n48+t30*t4*abb25n40)+t26*t3*abb25n34+t27*t3*abb25n34+t1*t1&
         &4*t20*abb25n34+t1*t17*t8*abb25n34+t11*t17*t5*abb25n34+t14*t2*t5*abb25n&
         &34)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d25:
   subroutine     reconstruct_d25(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_25:
      coeffs%coeffs_25%c0 = derivative(czip)
      coeffs%coeffs_25%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_25%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_25%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_25%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_25%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_25%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_25%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_25%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_25%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_25%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_25%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_25%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_25%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_25%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_25%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_25%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_25%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_25%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_25%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_25%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_25%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_25%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_25%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_25%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_25%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_25%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_25%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_25%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_25%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_25%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_25:
   end subroutine reconstruct_d25
!---#] subroutine reconstruct_d25:
end module p0_dubar_emnebarbbbar_d25h2l1d
