module     p0_dubar_emnebarbbbar_d24h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d24h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd24h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      real(ki) :: t52
      real(ki) :: t53
      real(ki) :: t54
      real(ki) :: t55
      real(ki) :: t56
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t52 = dotproduct(l5, qshift)
      t1 = (spval5l6(1)*qshift(1)-spval5l6(2)*qshift(2)-spval5l6(3)*qshift(3)-sp&
      &val5l6(4)*qshift(4))
      t2 = (spval5k4(1)*qshift(1)-spval5k4(2)*qshift(2)-spval5k4(3)*qshift(3)-sp&
      &val5k4(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spval5k1(3)*qshift(3)-sp&
      &val5k1(4)*qshift(4))
      t5 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t6 = (spval6k2(1)*qshift(1)-spval6k2(2)*qshift(2)-spval6k2(3)*qshift(3)-sp&
      &val6k2(4)*qshift(4))
      t53 = dotproduct(l6, qshift)
      t7 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t54 = dotproduct(k2, qshift)
      t55 = dotproduct(qshift, qshift)
      t56 = dotproduct(k1, qshift)
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spval5k2(1)*qshift(1)-spval5k2(2)*qshift(2)-spval5k2(3)*qshift(3)-sp&
      &val5k2(4)*qshift(4))
      t10 = (spval6k4(1)*qshift(1)-spval6k4(2)*qshift(2)-spval6k4(3)*qshift(3)-s&
      &pval6k4(4)*qshift(4))
      t11 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-s&
      &pvak2k4(4)*qshift(4))
      t12 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-s&
      &pvak3k2(4)*qshift(4))
      t13 = (spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-spvak1k2(3)*qshift(3)-s&
      &pvak1k2(4)*qshift(4))
      t14 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-s&
      &pvak2l5(4)*qshift(4))
      t15 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-s&
      &pval6l5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb24n59+t1*abb24n101+t2*abb24n102+t3*abb24n103+t4*abb24n1&
         &04+t5*abb24n105+t52*abb24n100+t53*abb24n110+t54*abb24n117+t54*t54*abb2&
         &4n76+t55*abb24n95+t56*abb24n96+t6*abb24n107+t7*abb24n111+t8*abb24n97+t&
         &9*abb24n98+abb24n106*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spva&
         &k3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+t1*t54*abb24n79+t10*t3*abb24n&
         &61+t10*t52*abb24n90+t10*t54*abb24n72+t10*t55*abb24n108+t10*t56*abb24n9&
         &1+t11*t4*abb24n63+t11*t5*abb24n60+t11*t52*abb24n87+t11*t54*abb24n84+t1&
         &1*t55*abb24n112+t11*t56*abb24n88+t11*t6*abb24n73+t11*t9*abb24n75+t12*t&
         &4*abb24n62+t13*t4*abb24n83+t14*t8*abb24n86+t15*t8*abb24n89+t2*t54*abb2&
         &4n74+t3*t53*abb24n65+t3*t6*abb24n70+t3*t8*abb24n92+t4*t54*abb24n69+t4*&
         &t6*abb24n67+t4*t7*abb24n66+t4*t8*abb24n94+t4*t9*abb24n68+t5*t54*abb24n&
         &71+t5*t7*abb24n64+t5*t8*abb24n93+t52*t54*abb24n82+t53*t54*abb24n77+t54&
         &*t55*abb24n114+t54*t56*abb24n81+t54*t8*abb24n85+t6*t7*abb24n78+t7*t9*a&
         &bb24n80+t3*t6*t8*abb24n119+t3*t8*t9*abb24n118+t5*t54*t8*abb24n120)
         return
      end if
      t16 = k1(iv1)
      t17 = k2(iv1)
      t18 = l5(iv1)
      t19 = l6(iv1)
      t20 = qshift(iv1)
      t21 = spvak2k1(iv1)
      t22 = spvak2l6(iv1)
      t23 = spvak3k4(iv1)
      t24 = spval5k1(iv1)
      t25 = spval5k2(iv1)
      t26 = spval5k4(iv1)
      t27 = spval5l6(iv1)
      t28 = spval6k1(iv1)
      t29 = spval6k2(iv1)
      t30 = spvak1k2(iv1)
      t31 = spvak2k4(iv1)
      t32 = spvak2l5(iv1)
      t33 = spvak3k2(iv1)
      t34 = spval6k4(iv1)
      t35 = spval6l5(iv1)
      if(deg.eq.1) then
         numerator = (spvak3k1(iv1)*abb24n106+t16*abb24n96+t17*abb24n117+t18*abb&
         &24n100+t19*abb24n110+t20*abb24n99+t21*abb24n103+t22*abb24n111+t23*abb2&
         &4n97+t24*abb24n104+t25*abb24n98+t26*abb24n102+t27*abb24n101+t28*abb24n&
         &105+t29*abb24n107+t1*t17*abb24n79+t10*t16*abb24n91+t10*t17*abb24n72+t1&
         &0*t18*abb24n90+t10*t20*abb24n109+t10*t21*abb24n61+t11*t16*abb24n88+t11&
         &*t17*abb24n84+t11*t18*abb24n87+t11*t20*abb24n113+t11*t24*abb24n63+t11*&
         &t25*abb24n75+t11*t28*abb24n60+t11*t29*abb24n73+t12*t24*abb24n62+t13*t2&
         &4*abb24n83+t14*t23*abb24n86+t15*t23*abb24n89+t16*t54*abb24n81+t17*t2*a&
         &bb24n74+t17*t4*abb24n69+t17*t5*abb24n71+t17*t52*abb24n82+t17*t53*abb24&
         &n77+t17*t54*abb24n116+t17*t55*abb24n114+t17*t56*abb24n81+t17*t8*abb24n&
         &85+t18*t54*abb24n82+t19*t3*abb24n65+t19*t54*abb24n77+t20*t54*abb24n115&
         &+t21*t53*abb24n65+t21*t6*abb24n70+t21*t8*abb24n92+t22*t4*abb24n66+t22*&
         &t5*abb24n64+t22*t6*abb24n78+t22*t9*abb24n80+t23*t3*abb24n92+t23*t4*abb&
         &24n94+t23*t5*abb24n93+t23*t54*abb24n85+t24*t54*abb24n69+t24*t6*abb24n6&
         &7+t24*t7*abb24n66+t24*t8*abb24n94+t24*t9*abb24n68+t25*t4*abb24n68+t25*&
         &t7*abb24n80+t26*t54*abb24n74+t27*t54*abb24n79+t28*t54*abb24n71+t28*t7*&
         &abb24n64+t28*t8*abb24n93+t29*t3*abb24n70+t29*t4*abb24n67+t29*t7*abb24n&
         &78+t3*t34*abb24n61+t30*t4*abb24n83+t31*t4*abb24n63+t31*t5*abb24n60+t31&
         &*t52*abb24n87+t31*t54*abb24n84+t31*t55*abb24n112+t31*t56*abb24n88+t31*&
         &t6*abb24n73+t31*t9*abb24n75+t32*t8*abb24n86+t33*t4*abb24n62+t34*t52*ab&
         &b24n90+t34*t54*abb24n72+t34*t55*abb24n108+t34*t56*abb24n91+t35*t8*abb2&
         &4n89+t17*t5*t8*abb24n120+t21*t6*t8*abb24n119+t21*t8*t9*abb24n118+t23*t&
         &3*t6*abb24n119+t23*t3*t9*abb24n118+t23*t5*t54*abb24n120+t25*t3*t8*abb2&
         &4n118+t28*t54*t8*abb24n120+t29*t3*t8*abb24n119)
         return
      end if
      t52 = d(iv1,iv2)
      t1 = k2(iv2)
      t2 = spvak2k4(iv2)
      t4 = spval6k4(iv2)
      t7 = k1(iv2)
      t12 = l5(iv2)
      t13 = l6(iv2)
      t14 = qshift(iv2)
      t15 = spvak3k4(iv2)
      t36 = t15*t17
      t37 = spval5k1(iv2)
      t38 = spval6k1(iv2)
      t39 = t17*t38
      t40 = t1*t23
      t41 = t1*t28
      t42 = spvak2k1(iv2)
      t43 = t15*t21
      t44 = spval6k2(iv2)
      t45 = t21*t44
      t46 = t23*t42
      t47 = t29*t42
      t48 = spval5k2(iv2)
      t49 = spvak2l6(iv2)
      t50 = t23*t38
      t51 = t15*t28
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t52*abb24n95+t1*t17*abb24n76+t10*t52*abb24n108+t&
         &11*t52*abb24n112+t52*t54*abb24n114)+t36*abb24n85+t39*abb24n71+t40*abb2&
         &4n85+t41*abb24n71+t43*abb24n92+t45*abb24n70+t46*abb24n92+t47*abb24n70+&
         &t50*abb24n93+t51*abb24n93+spvak1k2(iv2)*t24*abb24n83+spvak2l5(iv2)*t23&
         &*abb24n86+spvak3k2(iv2)*t24*abb24n62+spval5k4(iv2)*t17*abb24n74+spval5&
         &l6(iv2)*t17*abb24n79+spval6l5(iv2)*t23*abb24n89+t1*t16*abb24n81+t1*t18&
         &*abb24n82+t1*t19*abb24n77+t1*t20*abb24n115+t1*t24*abb24n69+t1*t26*abb2&
         &4n74+t1*t27*abb24n79+t1*t31*abb24n84+t1*t34*abb24n72+t12*t17*abb24n82+&
         &t12*t31*abb24n87+t12*t34*abb24n90+t13*t17*abb24n77+t13*t21*abb24n65+t1&
         &4*t17*abb24n115+t14*t31*abb24n113+t14*t34*abb24n109+t15*t24*abb24n94+t&
         &15*t32*abb24n86+t15*t35*abb24n89+t16*t2*abb24n88+t16*t4*abb24n91+t17*t&
         &2*abb24n84+t17*t37*abb24n69+t17*t4*abb24n72+t17*t7*abb24n81+t18*t2*abb&
         &24n87+t18*t4*abb24n90+t19*t42*abb24n65+t2*t20*abb24n113+t2*t24*abb24n6&
         &3+t2*t25*abb24n75+t2*t28*abb24n60+t2*t29*abb24n73+t20*t4*abb24n109+t21&
         &*t4*abb24n61+t22*t37*abb24n66+t22*t38*abb24n64+t22*t44*abb24n78+t22*t4&
         &8*abb24n80+t23*t37*abb24n94+t24*t44*abb24n67+t24*t48*abb24n68+t24*t49*&
         &abb24n66+t25*t37*abb24n68+t25*t49*abb24n80+t28*t49*abb24n64+t29*t37*ab&
         &b24n67+t29*t49*abb24n78+t30*t37*abb24n83+t31*t37*abb24n63+t31*t38*abb2&
         &4n60+t31*t44*abb24n73+t31*t48*abb24n75+t31*t7*abb24n88+t33*t37*abb24n6&
         &2+t34*t42*abb24n61+t34*t7*abb24n91+t36*t5*abb24n120+t39*t8*abb24n120+t&
         &40*t5*abb24n120+t41*t8*abb24n120+t43*t6*abb24n119+t43*t9*abb24n118+t45&
         &*t8*abb24n119+t46*t6*abb24n119+t46*t9*abb24n118+t47*t8*abb24n119+t50*t&
         &54*abb24n120+t51*t54*abb24n120+t15*t25*t3*abb24n118+t15*t29*t3*abb24n1&
         &19+t21*t48*t8*abb24n118+t23*t3*t44*abb24n119+t23*t3*t48*abb24n118+t25*&
         &t42*t8*abb24n118)
         return
      end if
      t53 = d(iv2,iv3)
      t54 = d(iv1,iv3)
      t3 = k2(iv3)
      t5 = spval6k1(iv3)
      t6 = spvak3k4(iv3)
      t7 = spval5k2(iv3)
      t8 = spval6k2(iv3)
      t9 = t21*t6
      t10 = t42*t6
      t11 = spvak2k1(iv3)
      t12 = t11*t23
      t11 = t11*t15
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t52*abb24n112+spval6k4(iv3)*t52*ab&
         &b24n108+t1*t54*abb24n114+t17*t53*abb24n114+t2*t54*abb24n112+t3*t52*abb&
         &24n114+t31*t53*abb24n112+t34*t53*abb24n108+t4*t54*abb24n108)+t10*t25*a&
         &bb24n118+t10*t29*abb24n119+t11*t25*abb24n118+t11*t29*abb24n119+t12*t44&
         &*abb24n119+t12*t48*abb24n118+t36*t5*abb24n120+t40*t5*abb24n120+t43*t7*&
         &abb24n118+t43*t8*abb24n119+t44*t9*abb24n119+t46*t7*abb24n118+t46*t8*ab&
         &b24n119+t48*t9*abb24n118+t1*t28*t6*abb24n120+t15*t28*t3*abb24n120+t17*&
         &t38*t6*abb24n120+t23*t3*t38*abb24n120)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p0_dubar_emnebarbbbar_d24h0l1d
