module     p0_dubar_emnebarbbbar_d27h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d27h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d27
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd27h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb27n28
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k3(iv1)
      t4 = k4(iv1)
      t5 = spvak3k1(iv1)
      t6 = spvak3k4(iv1)
      t7 = spval5k1(iv1)
      t8 = spval5k4(iv1)
      t9 = spval6k2(iv1)
      if(deg.eq.1) then
         numerator = (spval5l6(iv1)*abb27n47+t1*abb27n50+t2*abb27n48+t3*abb27n49&
         &+t4*abb27n49+t5*abb27n53+t6*abb27n51+t7*abb27n45+t8*abb27n46+t9*abb27n&
         &52)
         return
      end if
      t10 = k2(iv2)
      t11 = spval6k2(iv2)
      t12 = k1(iv2)
      t13 = k3(iv2)
      t14 = k4(iv2)
      t15 = spvak3k1(iv2)
      t16 = spvak3k4(iv2)
      t17 = spvak2k1(iv1)
      t18 = spval5k2(iv2)
      t19 = spvak2k1(iv2)
      t20 = spval5k2(iv1)
      t21 = spvak2k4(iv1)
      t22 = spvak2k4(iv2)
      if(deg.eq.2) then
         numerator = (spval5k1(iv2)*t2*abb27n44+spval5k4(iv2)*t2*abb27n37+spval6&
         &k1(iv1)*t10*abb27n42+spval6k1(iv2)*t2*abb27n42+spval6k4(iv1)*t10*abb27&
         &n35+spval6k4(iv2)*t2*abb27n35+t1*t10*abb27n32+t1*t11*abb27n39+t10*t3*a&
         &bb27n33+t10*t4*abb27n33+t10*t5*abb27n29+t10*t6*abb27n31+t10*t7*abb27n4&
         &4+t10*t8*abb27n37+t11*t17*abb27n41+t11*t21*abb27n34+t11*t3*abb27n40+t1&
         &1*t4*abb27n40+t11*t5*abb27n30+t11*t6*abb27n38+t12*t2*abb27n32+t12*t9*a&
         &bb27n39+t13*t2*abb27n33+t13*t9*abb27n40+t14*t2*abb27n33+t14*t9*abb27n4&
         &0+t15*t2*abb27n29+t15*t9*abb27n30+t16*t2*abb27n31+t16*t9*abb27n38+t17*&
         &t18*abb27n43+t18*t21*abb27n36+t19*t20*abb27n43+t19*t9*abb27n41+t20*t22&
         &*abb27n36+t22*t9*abb27n34)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d27:
   subroutine     reconstruct_d27(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_27:
      coeffs%coeffs_27%c0 = derivative(czip)
      coeffs%coeffs_27%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_27%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_27%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_27%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_27%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_27%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_27%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_27%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_27%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_27%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_27%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_27%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_27%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_27:
   end subroutine reconstruct_d27
!---#] subroutine reconstruct_d27:
end module p0_dubar_emnebarbbbar_d27h0l1d
