module     p0_dubar_emnebarbbbar_d1h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d1h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d1
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd1h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spval6l5(1)*qshift(1)-spval6l5(2)*qshift(2)-spval6l5(3)*qshift(3)-sp&
      &val6l5(4)*qshift(4))
      t37 = dotproduct(qshift, qshift)
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t38 = dotproduct(k3, qshift)
      t39 = dotproduct(k4, qshift)
      t40 = dotproduct(l5, qshift)
      t41 = dotproduct(l6, qshift)
      t3 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t42 = dotproduct(k2, qshift)
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-sp&
      &val6k1(4)*qshift(4))
      t6 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t7 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t8 = t42*abb1n61
      if(deg.eq.0) then
         numerator = (t1*abb1n34+t2*abb1n67+t3*abb1n78+t37*abb1n51+t38*t8+t38*ab&
         &b1n76+t39*t8+t39*abb1n76+t4*abb1n98+t40*abb1n77+t41*abb1n77+t42*abb1n8&
         &1+t5*abb1n99+abb1n100*(spval5k1(1)*qshift(1)-spval5k1(2)*qshift(2)-spv&
         &al5k1(3)*qshift(3)-spval5k1(4)*qshift(4))+t1*t3*abb1n57+t1*t37*abb1n70&
         &+t1*t38*abb1n64+t1*t39*abb1n64+t1*t6*abb1n50+t2*t37*abb1n103+t2*t6*abb&
         &1n41+t3*t42*abb1n56+t37*t4*abb1n92+t37*t42*abb1n73+t37*t5*abb1n96+t37*&
         &t6*abb1n84+t38*t4*abb1n48+t38*t5*abb1n46+t38*t6*abb1n54+t39*t4*abb1n48&
         &+t39*t5*abb1n46+t39*t6*abb1n54+t4*t6*abb1n36+t40*t6*abb1n52+t41*t6*abb&
         &1n52+t42*t6*abb1n49+t5*t6*abb1n38+t6*t7*abb1n39+t1*t4*t6*abb1n107+t4*t&
         &42*t6*abb1n109)
         return
      end if
      t8 = k2(iv1)
      t9 = k3(iv1)
      t10 = k4(iv1)
      t11 = l5(iv1)
      t12 = l6(iv1)
      t13 = qshift(iv1)
      t14 = spvak2k1(iv1)
      t15 = spvak2k4(iv1)
      t16 = spvak3k1(iv1)
      t17 = spval6k1(iv1)
      t18 = spval6l5(iv1)
      t19 = t8*abb1n75
      t20 = t14*abb1n90
      t21 = spvak3k4(iv1)
      t22 = t21*abb1n82
      t23 = t21*abb1n86
      t24 = spvak4k1(iv1)
      t25 = t17*abb1n94
      t26 = t18*abb1n68
      if(deg.eq.1) then
         numerator = (spval5k1(iv1)*abb1n42+t10*abb1n60+t11*abb1n59+t12*abb1n59+&
         &t13*abb1n87+t14*abb1n44+t15*abb1n58+t16*abb1n65+t17*abb1n43+t18*abb1n6&
         &6+t19*t38+t19*t39+t20*t38+t20*t39+t22*t38+t22*t39+t23*t40+t23*t41+t25*&
         &t38+t25*t39+t26*t38+t26*t39+t8*abb1n55+t9*abb1n60+t1*t10*abb1n68+t1*t1&
         &3*abb1n69+t1*t15*abb1n79+t1*t21*abb1n88+t1*t9*abb1n68+t10*t4*abb1n90+t&
         &10*t42*abb1n75+t10*t5*abb1n94+t10*t6*abb1n82+t11*t6*abb1n86+t12*t6*abb&
         &1n86+t13*t2*abb1n102+t13*t4*abb1n91+t13*t42*abb1n72+t13*t5*abb1n95+t13&
         &*t6*abb1n83+t14*t37*abb1n47+t14*t6*abb1n108+t15*t42*abb1n80+t16*t37*ab&
         &b1n40+t16*t6*abb1n101+t17*t37*abb1n45+t17*t6*abb1n106+t18*t3*abb1n79+t&
         &18*t37*abb1n63+t18*t6*abb1n88+t2*t21*abb1n101+t21*t37*abb1n53+t21*t4*a&
         &bb1n108+t21*t42*abb1n89+t21*t5*abb1n106+t21*t7*abb1n105+t24*t6*abb1n10&
         &5+t3*t8*abb1n80+t37*t8*abb1n62+t4*t9*abb1n90+t42*t9*abb1n75+t5*t9*abb1&
         &n94+t6*t8*abb1n89+t6*t9*abb1n82+t1*t14*t6*abb1n37+t1*t21*t4*abb1n37+t1&
         &4*t42*t6*abb1n35+t18*t4*t6*abb1n37+t21*t4*t42*abb1n35+t4*t6*t8*abb1n35&
         &)
         return
      end if
      t37 = d(iv1,iv2)
      t3 = k3(iv2)
      t7 = k4(iv2)
      t19 = qshift(iv2)
      t20 = spvak2k4(iv2)
      t22 = spvak3k4(iv2)
      t23 = t22*t8
      t25 = k2(iv2)
      t26 = t21*t25
      t27 = spvak2k1(iv2)
      t28 = spval6k1(iv2)
      t29 = spval6l5(iv2)
      t30 = spvak3k1(iv2)
      t31 = t14*t22
      t32 = t21*t27
      t33 = t21*t29
      t34 = t18*t22
      t35 = t27*t8
      t36 = t14*t25
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t37*abb1n51+t1*t37*abb1n70+t2*t37*abb1n103+t37*t&
         &4*abb1n92+t37*t42*abb1n73+t37*t5*abb1n96+t37*t6*abb1n84)+t23*abb1n49+t&
         &26*abb1n49+t31*abb1n36+t32*abb1n36+t33*abb1n50+t34*abb1n50+l5(iv2)*t21&
         &*abb1n52+l6(iv2)*t21*abb1n52+spvak4k1(iv2)*t21*abb1n39+t1*t31*abb1n107&
         &+t1*t32*abb1n107+t10*t22*abb1n54+t10*t25*abb1n61+t10*t27*abb1n48+t10*t&
         &28*abb1n46+t10*t29*abb1n64+t11*t22*abb1n52+t12*t22*abb1n52+t13*t22*abb&
         &1n85+t13*t25*abb1n74+t13*t27*abb1n93+t13*t28*abb1n97+t13*t29*abb1n71+t&
         &13*t30*abb1n104+t14*t19*abb1n93+t14*t3*abb1n48+t14*t7*abb1n48+t15*t25*&
         &abb1n56+t15*t29*abb1n57+t16*t19*abb1n104+t16*t22*abb1n41+t17*t19*abb1n&
         &97+t17*t22*abb1n38+t17*t3*abb1n46+t17*t7*abb1n46+t18*t19*abb1n71+t18*t&
         &20*abb1n57+t18*t3*abb1n64+t18*t7*abb1n64+t19*t21*abb1n85+t19*t8*abb1n7&
         &4+t20*t8*abb1n56+t21*t28*abb1n38+t21*t3*abb1n54+t21*t30*abb1n41+t21*t7&
         &*abb1n54+t22*t24*abb1n39+t22*t9*abb1n54+t23*t4*abb1n109+t25*t9*abb1n61&
         &+t26*t4*abb1n109+t27*t9*abb1n48+t28*t9*abb1n46+t29*t9*abb1n64+t3*t8*ab&
         &b1n61+t31*t42*abb1n109+t32*t42*abb1n109+t33*t4*abb1n107+t34*t4*abb1n10&
         &7+t35*t6*abb1n109+t36*t6*abb1n109+t7*t8*abb1n61+t14*t29*t6*abb1n107+t1&
         &8*t27*t6*abb1n107)
         return
      end if
      t38 = d(iv2,iv3)
      t39 = d(iv1,iv3)
      t1 = k2(iv3)
      t2 = spvak2k1(iv3)
      t3 = spvak3k4(iv3)
      t4 = spval6l5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t37*abb1n40+spval6k1(iv3)*t37*abb1&
         &n45+t1*t37*abb1n62+t14*t38*abb1n47+t16*t38*abb1n40+t17*t38*abb1n45+t18&
         &*t38*abb1n63+t2*t37*abb1n47+t21*t38*abb1n53+t22*t39*abb1n53+t25*t39*ab&
         &b1n62+t27*t39*abb1n47+t28*t39*abb1n45+t29*t39*abb1n63+t3*t37*abb1n53+t&
         &30*t39*abb1n40+t37*t4*abb1n63+t38*t8*abb1n62)+t3*t35*abb1n35+t3*t36*ab&
         &b1n35+t31*t4*abb1n37+t32*t4*abb1n37+t1*t14*t22*abb1n35+t1*t21*t27*abb1&
         &n35+t14*t29*t3*abb1n37+t18*t2*t22*abb1n37+t18*t27*t3*abb1n37+t2*t21*t2&
         &5*abb1n35+t2*t21*t29*abb1n37+t2*t22*t8*abb1n35)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d1:
   subroutine     reconstruct_d1(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_1:
      coeffs%coeffs_1%c0 = derivative(czip)
      coeffs%coeffs_1%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_1%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_1%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_1%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_1%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_1%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_1%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_1%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_1%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_1%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_1%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_1%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_1%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_1%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_1%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_1%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_1%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_1%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_1%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_1%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_1%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_1%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_1%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_1%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_1%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_1%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_1%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_1%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_1:
   end subroutine reconstruct_d1
!---#] subroutine reconstruct_d1:
end module p0_dubar_emnebarbbbar_d1h1l1d
