module     p0_dubar_emnebarbbbar_abbrevd9h2
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_globalsh2
   implicit none
   private
   complex(ki), public :: abb9n1
   complex(ki), public :: abb9n2
   complex(ki), public :: abb9n3
   complex(ki), public :: abb9n4
   complex(ki), public :: abb9n5
   complex(ki), public :: abb9n6
   complex(ki), public :: rat2d9
   complex(ki), public :: abb9n8
   complex(ki), public :: abb9n9
   complex(ki), public :: abb9n10
   complex(ki), public :: abb9n11
   complex(ki), public :: abb9n12
   complex(ki), public :: abb9n13
   complex(ki), public :: abb9n14
   complex(ki), public :: abb9n15
   complex(ki), public :: abb9n16
   complex(ki), public :: abb9n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   real(ki) :: t36
   real(ki) :: t37
   real(ki) :: t38
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebarbbbar_config, only: deltaOS
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_model
      use p0_dubar_emnebarbbbar_color, only: TR
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak2k3
      t3 = t2*spak2l5*spbk4k1
      t36 = TR*TR
      t4 = t36*t3*spbl6k2
      t5 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t6 = es56*t5
      t7 = t4/t6
      t8 = t1*spak2l5
      t9 = t36*t8*spak3l5*spbk4k1*spbl6l5
      t10 = t9/t6
      t37 = NC*NC
      t11 = t37*t6
      t4 = t4/t11
      t9 = t9/t11
      t12 = c2*i_
      t13 = t12*spak2k3
      t14 = t13*spak2l5*spbk4k1
      t5 = es56*NC*t5
      t15 = t36*t14/t5*spbl6k2
      t16 = t12*spak2l5
      t17 = t36*t16/t5*spak3l5*spbk4k1*spbl6l5
      t18 = NC*c2*i_
      t19 = t18*spak2k3
      t20 = t19*spak2l5*spbk4k1
      t21 = t36*t20/t6*spbl6k2
      t22 = t18*spak2l5
      t23 = t36*t22/t6*spak3l5*spbk4k1*spbl6l5
      t38 = TR*mB
      t38 = t38*t38
      t3 = t38*t3
      t24 = t6*spak2l6
      t25 = t3/t24
      t2 = t38*t2*spbk4k1*spbl6k2
      t26 = t6*spbl5k2
      t27 = t2/t26
      t28 = t37*t24
      t3 = t3/t28
      t29 = t37*t26
      t2 = t2/t29
      t30 = t5*spak2l6
      t14 = t38*t14/t30
      t31 = t5*spbl5k2
      t13 = t38*t13/t31*spbk4k1*spbl6k2
      t20 = t38*t20/t24
      t19 = t38*t19/t26*spbk4k1*spbl6k2
      abb9n1 = ((2.0_ki)*(t13+t14+t21+t23+t25+t27+t4+t9-(t7+t3+t20+t2+t19+t17+t1&
      &5+t10)))
      t32 = t8*spak3k4*spbk4k1
      t33 = t36*t32*spbl6l5
      t34 = t16*spak3k4*spbk4k1
      t35 = t22*spak3k4*spbk4k1
      abb9n2 = ((4.0_ki)*(t33/t11+t36*t35/t6*spbl6l5-(t36*t34/t5*spbl6l5+t33/t6)&
      &))
      abb9n3 = ((4.0_ki)*(t10+t15+t17+t19+t2+t20+t3+t7-(t9+t4+t27+t25+t23+t21+t1&
      &4+t13)))
      t2 = t36*t32*spbl6k2
      t3 = t38*t32
      t4 = t38*t1*spak3k4*spbk4k1*spbl6k2
      abb9n4 = ((4.0_ki)*(t2/t6+t3/t28+t4/t29+t38*t35/t24+t36*t34/t5*spbl6k2+t38&
      &*t18/t26*spak3k4*spbk4k1*spbl6k2-(t38*t12/t31*spak3k4*spbk4k1*spbl6k2+t36&
      &*t35/t6*spbl6k2+t38*t34/t30+t4/t26+t3/t24+t2/t11)))
      t2 = t36*t8*spbl6l5
      abb9n5 = ((4.0_ki)*(t2/t6+t36*t16/t5*spbl6l5-(t36*t22/t6*spbl6l5+t2/t11)))
      t2 = t36*t8*spbl6k2
      t3 = t38*t8
      t1 = t38*t1*spbl6k2
      abb9n6 = ((4.0_ki)*(t1/t26+t2/t11+t3/t24+t38*t16/t30+t38*t12/t31*spbl6k2+t&
      &36*t22/t6*spbl6k2-(t38*t18/t26*spbl6k2+t36*t16/t5*spbl6k2+t38*t22/t24+t3/&
      &t28+t2/t6+t1/t29)))
      rat2d9 = abb9n1
      rat2 = rat2 + rat2d9
      abb9n8 = -(abb9n2)
      abb9n9 = abb9n6
      abb9n10 = abb9n5
      abb9n11 = abb9n4
      abb9n12 = abb9n3
      abb9n13 = abb9n2
      abb9n14 = (-2.0_ki)*abb9n3
      abb9n15 = -(abb9n4)
      abb9n16 = -(abb9n5)
      abb9n17 = -(abb9n6)
   end subroutine
end module p0_dubar_emnebarbbbar_abbrevd9h2
