module     p0_dubar_emnebarbbbar_d12h2l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity2/d12h2l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d12
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd12h2
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      real(ki) :: t11
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t2 = (spval5l6(1)*qshift(1)-spval5l6(2)*qshift(2)-spval5l6(3)*qshift(3)-sp&
      &val5l6(4)*qshift(4))
      t11 = dotproduct(k2, qshift)
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb12n24+t1*abb12n47+t11*abb12n57+t2*abb12n54+t3*abb12n64+&
         &abb12n37*dotproduct(qshift, qshift)+abb12n45*(spval5k4(1)*qshift(1)-sp&
         &val5k4(2)*qshift(2)-spval5k4(3)*qshift(3)-spval5k4(4)*qshift(4))+abb12&
         &n49*(spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)&
         &-spvak2l5(4)*qshift(4))+abb12n50*(spvak3l5(1)*qshift(1)-spvak3l5(2)*qs&
         &hift(2)-spvak3l5(3)*qshift(3)-spvak3l5(4)*qshift(4))+abb12n51*(spvak2l&
         &6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-spvak2l6(4)&
         &*qshift(4))+abb12n53*dotproduct(l5, qshift)+abb12n53*dotproduct(l6, qs&
         &hift)+abb12n55*(spvak3l6(1)*qshift(1)-spvak3l6(2)*qshift(2)-spvak3l6(3&
         &)*qshift(3)-spvak3l6(4)*qshift(4))+abb12n56*(spvak3k2(1)*qshift(1)-spv&
         &ak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-spvak3k2(4)*qshift(4))+abb12n&
         &58*(spval6k1(1)*qshift(1)-spval6k1(2)*qshift(2)-spval6k1(3)*qshift(3)-&
         &spval6k1(4)*qshift(4))+abb12n61*(spval5k1(1)*qshift(1)-spval5k1(2)*qsh&
         &ift(2)-spval5k1(3)*qshift(3)-spval5k1(4)*qshift(4))+t1*t11*abb12n41+t1&
         &*t2*abb12n43+t11*t3*abb12n29+t11*t4*abb12n26+t2*t3*abb12n30+t2*t4*abb1&
         &2n27)
         return
      end if
      t5 = k2(iv1)
      t6 = spvak2k1(iv1)
      t7 = spvak2k4(iv1)
      t8 = spval5l6(iv1)
      t9 = spvak3k1(iv1)
      if(deg.eq.1) then
         numerator = (l5(iv1)*abb12n36+l6(iv1)*abb12n36+qshift(iv1)*abb12n52+spv&
         &ak2l5(iv1)*abb12n40+spvak2l6(iv1)*abb12n38+spvak3k2(iv1)*abb12n33+spva&
         &k3l5(iv1)*abb12n39+spvak3l6(iv1)*abb12n34+spval5k1(iv1)*abb12n28+spval&
         &5k4(iv1)*abb12n44+spval6k1(iv1)*abb12n31+t5*abb12n32+t6*abb12n25+t7*ab&
         &b12n42+t8*abb12n35+t1*t5*abb12n48+t1*t8*abb12n46+t11*t6*abb12n60+t11*t&
         &7*abb12n48+t11*t9*abb12n63+t2*t6*abb12n59+t2*t7*abb12n46+t2*t9*abb12n6&
         &2+t3*t5*abb12n60+t3*t8*abb12n59+t4*t5*abb12n63+t4*t8*abb12n62)
         return
      end if
      t1 = spvak2k1(iv2)
      t2 = spvak2k4(iv2)
      t3 = spvak3k1(iv2)
      t4 = k2(iv2)
      t10 = spval5l6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb12n37+t1*t5*abb12n29+t1*t8*abb12n30&
         &+t10*t6*abb12n30+t10*t7*abb12n43+t10*t9*abb12n27+t2*t5*abb12n41+t2*t8*&
         &abb12n43+t3*t5*abb12n26+t3*t8*abb12n27+t4*t6*abb12n29+t4*t7*abb12n41+t&
         &4*t9*abb12n26)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d12:
   subroutine     reconstruct_d12(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_12:
      coeffs%coeffs_12%c0 = derivative(czip)
      coeffs%coeffs_12%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_12%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_12%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_12%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_12%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_12%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_12%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_12%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_12%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_12%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_12%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_12%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_12%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_12%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_12:
   end subroutine reconstruct_d12
!---#] subroutine reconstruct_d12:
end module p0_dubar_emnebarbbbar_d12h2l1d
