module     p0_dubar_emnebarbbbar_abbrevd27h3
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_globalsh3
   implicit none
   private
   complex(ki), public :: abb27n1
   complex(ki), public :: abb27n2
   complex(ki), public :: abb27n3
   complex(ki), public :: abb27n4
   complex(ki), public :: abb27n5
   complex(ki), public :: abb27n6
   complex(ki), public :: abb27n7
   complex(ki), public :: abb27n8
   complex(ki), public :: abb27n9
   complex(ki), public :: abb27n10
   complex(ki), public :: rat2d27
   complex(ki), public :: abb27n12
   complex(ki), public :: abb27n13
   complex(ki), public :: abb27n14
   complex(ki), public :: abb27n15
   complex(ki), public :: abb27n16
   complex(ki), public :: abb27n17
   complex(ki), public :: abb27n18
   complex(ki), public :: abb27n19
   complex(ki), public :: abb27n20
   complex(ki), public :: abb27n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   real(ki) :: t14
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_dubar_emnebarbbbar_config, only: deltaOS
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_model
      use p0_dubar_emnebarbbbar_color, only: TR
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      implicit none
      t1 = sqrt((mB*mB))
      t2 = t1*c2*i_
      t3 = t2*spak2k3
      t13 = TR*TR
      t4 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t5 = NC*t4
      t6 = t1*c1*i_
      t7 = t6*spak2k3
      t14 = NC*NC
      t8 = t14*t4
      t1 = NC*t1*c2*i_
      t9 = t1*spak2k3
      abb27n1 = ((8.0_ki)*(t13*t3/t5*spbk3k1*spbl6l5+t13*t2/t5*spak2k4*spbk4k1*s&
      &pbl6l5)+(4.0_ki)*(-(t13*t6/t8*spak2k4*spbk4k1*spbl6l5+t13*t1/t4*spak2k4*s&
      &pbk4k1*spbl6l5+t13*t7/t8*spbk3k1*spbl6l5+t13/t4*t9*spbk3k1*spbl6l5)))
      t10 = t13*t7/t8*spbk4k1*spbl6l5
      t11 = (2.0_ki)*t13*t3/t5*spbk4k1*spbl6l5
      t12 = t13/t4*t9*spbk4k1*spbl6l5
      abb27n2 = ((8.0_ki)*(t10+t12-t11))
      abb27n3 = ((8.0_ki)*(t11-(t12+t10)))
      abb27n4 = ((8.0_ki)*(-(t13*t2/t5*spak3k4*spbk4k1*spbl6k4+t13*t2/t5*spak1k3&
      &*spbk4k1*spbl6k1))+(4.0_ki)*(t13*t1/t4*spak1k3*spbk4k1*spbl6k1+t13*t1/t4*&
      &spak3k4*spbk4k1*spbl6k4+t13*t6/t8*spak1k3*spbk4k1*spbl6k1+t13*t6/t8*spak3&
      &k4*spbk4k1*spbl6k4))
      abb27n5 = ((8.0_ki)*(t13*t3/t5*spbk4k3*spbl6l5+t13*t2/t5*spak1k2*spbk4k1*s&
      &pbl6l5)+(4.0_ki)*(-(t13*t6/t8*spak1k2*spbk4k1*spbl6l5+t13*t1/t4*spak1k2*s&
      &pbk4k1*spbl6l5+t13*t7/t8*spbk4k3*spbl6l5+t13/t4*t9*spbk4k3*spbl6l5)))
      t1 = mB*c1*i_
      t2 = t1*spak2k3
      t3 = t4*spak2l5
      t4 = t14*t3
      t6 = t13*t2/t4*spbk4k1
      t7 = mB*c2*i_
      t8 = t7*spak2k3
      t5 = t5*spak2l5
      t9 = (2.0_ki)*t13/t5*t8*spbk4k1
      t10 = mB*NC*c2*i_
      t11 = t10*spak2k3
      t12 = t13*t11/t3*spbk4k1
      abb27n6 = ((8.0_ki)*(t12+t6-t9))
      abb27n7 = ((8.0_ki)*(t9-(t6+t12)))
      abb27n8 = ((8.0_ki)*(-(t13/t5*t7*spak2k4*spbk4k1+t13/t5*t8*spbk3k1))+(4.0_&
      &ki)*(t13*t11/t3*spbk3k1+t13*t2/t4*spbk3k1+t13*t1/t4*spak2k4*spbk4k1+t13*t&
      &10/t3*spak2k4*spbk4k1))
      abb27n9 = ((8.0_ki)*(-(t13/t5*t7*spak2l6*spak3k4*spbk4k1*spbl6k4+t13/t5*t7&
      &*spak1k3*spak2l6*spbk4k1*spbl6k1))+(4.0_ki)*(t13*t1/t4*spak1k3*spak2l6*sp&
      &bk4k1*spbl6k1+t13*t1/t4*spak2l6*spak3k4*spbk4k1*spbl6k4+t13*t10/t3*spak1k&
      &3*spak2l6*spbk4k1*spbl6k1+t13*t10/t3*spak2l6*spak3k4*spbk4k1*spbl6k4))
      abb27n10 = ((8.0_ki)*(-(t13/t5*t7*spak1k2*spbk4k1+t13/t5*t8*spbk4k3))+(4.0&
      &_ki)*(t13*t11/t3*spbk4k3+t13*t2/t4*spbk4k3+t13*t1/t4*spak1k2*spbk4k1+t13*&
      &t10/t3*spak1k2*spbk4k1))
      rat2d27 = 0
      rat2 = rat2 + rat2d27
      abb27n12 = -(abb27n1)
      abb27n13 = abb27n10
      abb27n14 = abb27n8
      abb27n15 = abb27n7
      abb27n16 = abb27n6
      abb27n17 = -(abb27n2)
      abb27n18 = -(abb27n3)
      abb27n19 = -(abb27n4)
      abb27n20 = -(abb27n5)
      abb27n21 = -(abb27n9)
   end subroutine
end module p0_dubar_emnebarbbbar_abbrevd27h3
