module     p0_dubar_emnebarbbbar_d1h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity3/d1h3l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d1
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd1h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak2l6(1)*qshift(1)-spvak2l6(2)*qshift(2)-spvak2l6(3)*qshift(3)-sp&
      &vak2l6(4)*qshift(4))
      t31 = dotproduct(qshift, qshift)
      t2 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t3 = (spvak2l5(1)*qshift(1)-spvak2l5(2)*qshift(2)-spvak2l5(3)*qshift(3)-sp&
      &vak2l5(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t32 = dotproduct(k3, qshift)
      t33 = dotproduct(k4, qshift)
      if(deg.eq.0) then
         numerator = (t1*abb1n20+t2*abb1n47+t3*abb1n48+t31*abb1n29+t4*abb1n60+t1&
         &*t2*abb1n30+t1*t31*abb1n45+t1*t32*abb1n35+t1*t33*abb1n35+t1*t5*abb1n27&
         &+t2*t3*abb1n31+t3*t31*abb1n41+t3*t32*abb1n37+t3*t33*abb1n37+t3*t5*abb1&
         &n28+t31*t4*abb1n56+t32*t4*abb1n26+t33*t4*abb1n26+t4*t5*abb1n24+t1*t4*t&
         &5*abb1n61+t3*t4*t5*abb1n59)
         return
      end if
      t6 = qshift(iv1)
      t7 = spvak2k1(iv1)
      t8 = spvak2k4(iv1)
      t9 = spvak2l5(iv1)
      t10 = spvak2l6(iv1)
      t11 = k3(iv1)
      t12 = k4(iv1)
      t13 = t7*abb1n54
      t14 = t9*abb1n39
      t15 = t10*abb1n43
      t16 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb1n38+t13*t32+t13*t33+t14*t32+t14*t33+t15*t32+t15*t3&
         &3+t6*abb1n51+t7*abb1n22+t8*abb1n33+t9*abb1n32+t1*t11*abb1n43+t1*t12*ab&
         &b1n43+t1*t16*abb1n53+t1*t6*abb1n44+t1*t8*abb1n50+t10*t2*abb1n50+t10*t3&
         &1*abb1n34+t10*t5*abb1n53+t11*t3*abb1n39+t11*t4*abb1n54+t12*t3*abb1n39+&
         &t12*t4*abb1n54+t16*t3*abb1n52+t16*t4*abb1n58+t2*t9*abb1n49+t3*t6*abb1n&
         &40+t3*t8*abb1n49+t31*t7*abb1n25+t31*t9*abb1n36+t4*t6*abb1n55+t5*t7*abb&
         &1n58+t5*t9*abb1n52+t1*t16*t4*abb1n21+t1*t5*t7*abb1n21+t10*t4*t5*abb1n2&
         &1+t16*t3*t4*abb1n23+t3*t5*t7*abb1n23+t4*t5*t9*abb1n23)
         return
      end if
      t31 = d(iv1,iv2)
      t2 = spvak2k1(iv2)
      t13 = spvak2l5(iv2)
      t14 = spvak2l6(iv2)
      t15 = k3(iv2)
      t17 = k4(iv2)
      t18 = qshift(iv2)
      t19 = spvak3k4(iv2)
      t20 = t19*t7
      t21 = t16*t2
      t22 = spvak2k4(iv2)
      t23 = t19*t9
      t24 = t13*t16
      t25 = t10*t19
      t26 = t14*t16
      t27 = t13*t7
      t28 = t14*t7
      t29 = t2*t9
      t30 = t10*t2
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t31*abb1n29+t1*t31*abb1n45+t3*t31*abb1n41+t31*t4&
         &*abb1n56)+t20*abb1n24+t21*abb1n24+t23*abb1n28+t24*abb1n28+t25*abb1n27+&
         &t26*abb1n27+t1*t20*abb1n61+t1*t21*abb1n61+t10*t15*abb1n35+t10*t17*abb1&
         &n35+t10*t18*abb1n46+t10*t22*abb1n30+t11*t13*abb1n37+t11*t14*abb1n35+t1&
         &1*t2*abb1n26+t12*t13*abb1n37+t12*t14*abb1n35+t12*t2*abb1n26+t13*t6*abb&
         &1n42+t13*t8*abb1n31+t14*t6*abb1n46+t14*t8*abb1n30+t15*t7*abb1n26+t15*t&
         &9*abb1n37+t17*t7*abb1n26+t17*t9*abb1n37+t18*t7*abb1n57+t18*t9*abb1n42+&
         &t2*t6*abb1n57+t20*t3*abb1n59+t21*t3*abb1n59+t22*t9*abb1n31+t23*t4*abb1&
         &n59+t24*t4*abb1n59+t25*t4*abb1n61+t26*t4*abb1n61+t27*t5*abb1n59+t28*t5&
         &*abb1n61+t29*t5*abb1n59+t30*t5*abb1n61)
         return
      end if
      t32 = d(iv2,iv3)
      t33 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t3 = spvak2l5(iv3)
      t4 = spvak2l6(iv3)
      t5 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t31*abb1n25+t10*t32*abb1n34+t13*t33*abb1n36+t&
         &14*t33*abb1n34+t2*t33*abb1n25+t3*t31*abb1n36+t31*t4*abb1n34+t32*t7*abb&
         &1n25+t32*t9*abb1n36)+t27*t5*abb1n23+t28*t5*abb1n21+t29*t5*abb1n23+t30*&
         &t5*abb1n21+t1*t10*t19*abb1n21+t1*t13*t16*abb1n23+t1*t14*t16*abb1n21+t1&
         &*t19*t9*abb1n23+t16*t2*t3*abb1n23+t16*t2*t4*abb1n21+t19*t3*t7*abb1n23+&
         &t19*t4*t7*abb1n21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d1:
   subroutine     reconstruct_d1(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_1:
      coeffs%coeffs_1%c0 = derivative(czip)
      coeffs%coeffs_1%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_1%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_1%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_1%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_1%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_1%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_1%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_1%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_1%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_1%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_1%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_1%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_1%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_1%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_1%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_1%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_1%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_1%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_1%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_1%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_1%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_1%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_1%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_1%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_1%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_1%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_1%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_1%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_1%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_1%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_1:
   end subroutine reconstruct_d1
!---#] subroutine reconstruct_d1:
end module p0_dubar_emnebarbbbar_d1h3l1d
